<?php
// $Id: gamertags.inc,v 1.1.2.3 2009/11/09 12:30:28 pobster Exp $

/**
 * @file
 * Panels specific include file for implementing Gamertags in Panels.
 */

/**
 * Implementation of hook_ctools_content_types().
 */
function gamertags_gamertags_ctools_content_types() {
  return array(
    'single' => TRUE,
    'title' => t('Gamertags'),
    'icon' => 'icon_user.png',
    'description' => t('Gamertags from the Gamertags module.'),
    'required context' => new ctools_context_required(t('User'), 'user'),
    'category' => t('User'),
  );
} // gamertags_gamertags_ctools_content_types

/**
 * Callback for admin_title.
 */
function gamertags_gamertags_content_type_admin_title($subtype, $conf, $context = NULL) {
  $output = t('Gamertags');
  if ($conf['override_title'] && !empty($conf['override_title_text'])) {
    $output = filter_xss_admin($conf['override_title_text']);
  }
  return $output;
} // gamertags_gamertags_admin_title

/**
 * Callback for admin_info.
 */
function gamertags_gamertags_content_type_admin_info($subtype, $conf, $context = NULL) {
  $block = new stdClass();
  $block->title = !empty($conf['title']) ? check_plain($conf['title']) : '';
  if (!empty($context) && !empty($context->data->description)) {
    $block->content = check_plain($context->data->description);
  }
  return $block;
} // gamertags_gamertags_admin_info

/**
 * Callback for edit_form so we pick up %user argument.
 */
function gamertags_gamertags_content_type_edit_form(&$form, &$form_state) {
} // gamertags_gamertags_content_type_edit_form

/**
 * Callback which renders our Gamertags.
 */
function gamertags_gamertags_content_type_render($subtype, $conf, $panel_args, $context) {
  $account = isset($context->data) ? drupal_clone($context->data) : NULL;
  $block = new stdClass();
  $block->title = "Gamertags";

  if ($account) {
    drupal_add_css(drupal_get_path('module', 'gamertags') .'/gamertags.css');
    $block->content = _gamertags_render_panel_content($account);
  }
  else {
    $block->content = t("User information not available");
  }

  return $block;
} // gamertags_gamertags_content_type_render

/**
 * Helper function to spit out an item list of Gamertags.
 */
function _gamertags_render_panel_content($user) {
  $output = array();
  if (variable_get('gamertags_collect_xbox', TRUE) && $user->xbox_gamertag) {
    $output[] = gamertags('fetch', 'xbox', $user->xbox_gamertag);
  }
  if (variable_get('gamertags_collect_ps3', TRUE) && $user->psn_gamertag) {
    $output[] = gamertags('fetch', 'playstation', $user->psn_gamertag, $user->psn_region);
  }
  if (variable_get('gamertags_collect_wii', TRUE) && $user->wii_gamertag) {
    $output[] = gamertags('fetch', 'wii', $user->wii_gamertag);
  }
  if (variable_get('gamertags_collect_steam', TRUE) && $user->steam_gamertag) {
    $output[] = gamertags('fetch', 'steam', $user->steam_gamertag);
  }
  return theme('item_list', $output, NULL, 'ul', array('id' => 'gamertags_panels'));
} //_gamertags_render_panel_content